#include "int.h"
#include "stdio.h"


void reset_exception(void)
{
	printf("reset_exception.\n");
}

void undef_exception(void)
{
	printf("undef_exception.\n");
}

void sotf_int_exception(void)
{
	printf("sotf_int_exception.\n");
}

void prefetch_exception(void)
{
	printf("prefetch_exception.\n");
}

void data_exception(void)
{
	printf("data_exception.\n");
}

// Ҫܣ󶨵һ׶쳣ֹжϣѡжΪIRQ
// VICnADDRΪ0
void system_init_exception(void)
{
	// һ׶δ쳣
	r_exception_reset = (unsigned int)reset_exception;
	r_exception_undef = (unsigned int)undef_exception;
	r_exception_sotf_int = (unsigned int)sotf_int_exception;
	r_exception_prefetch = (unsigned int)prefetch_exception;
	r_exception_data = (unsigned int)data_exception;
	r_exception_irq = (unsigned int)IRQ_handle;
	r_exception_fiq = (unsigned int)IRQ_handle;
	
	// ʼжϿĻĴ
	intc_init();
}

// Ҫжϵжϴĵַ
void intc_clearvectaddr(void)
{
    // VICxADDR:ǰڴжϵжϴĵַ
    VIC0ADDR = 0;
    VIC1ADDR = 0;
    VIC2ADDR = 0;
    VIC3ADDR = 0;
}

// ʼжϿ
void intc_init(void)
{
    // ֹж
	// Ϊʲôжϳʼ֮Ҫֹжϣ
	// Ϊжһ򿪣ΪⲿӲԼԭжϺһͻѰisr
	// ǿΪԼòжϾûṩisrʱԶõľ
	// ܷܿɣԲõжһҪص
	// һȫصȻһԼȤжϡһ򿪾ͱ
	// жṩӦisr󶨺á
    VIC0INTENCLEAR = 0xffffffff;
    VIC1INTENCLEAR = 0xffffffff;
    VIC2INTENCLEAR = 0xffffffff;
    VIC3INTENCLEAR = 0xffffffff;

    // ѡжΪIRQ
    VIC0INTSELECT = 0x0;
    VIC1INTSELECT = 0x0;
    VIC2INTSELECT = 0x0;
    VIC3INTSELECT = 0x0;

    // VICxADDR
    intc_clearvectaddr();
}


// дisrVICnVECTADDRĴ
// 󶨹֮ǾͰisrַӲˣʣµǲùˣӲԼᴦ
// ȷӦжϵʱֱӵӦVICnADDRȥȡisrַɡ
// intnumint.hжϺţhandlerǺָ룬дisr

// VIC0VECTADDRΪVIC0VECTADDR0Ĵĵַ൱VIC0VECTADDR031
// 飨һָ飩׵ַȻÿһжϵʱ
// ֻҪ׵ַ+ƫɡ
void intc_setvectaddr(unsigned long intnum, void (*handler)(void))
{
    //VIC0
    if(intnum<32)
    {
        *( (volatile unsigned long *)(VIC0VECTADDR + 4*(intnum-0)) ) = (unsigned)handler;
    }
    //VIC1
    else if(intnum<64)
    {
        *( (volatile unsigned long *)(VIC1VECTADDR + 4*(intnum-32)) ) = (unsigned)handler;
    }
    //VIC2
    else if(intnum<96)
    {
        *( (volatile unsigned long *)(VIC2VECTADDR + 4*(intnum-64)) ) = (unsigned)handler;
    }
    //VIC3
    else
    {
        *( (volatile unsigned long *)(VIC3VECTADDR + 4*(intnum-96)) ) = (unsigned)handler;
    }
    return;
}


// ʹж
// ͨεintnumʹĳжԴжϺint.hж壬жϺ
void intc_enable(unsigned long intnum)
{
    unsigned long temp;
	// ȷintnumĸĴһλ
	// <32031ȻVIC0
    if(intnum<32)
    {
        temp = VIC0INTENABLE;
        temp |= (1<<intnum);		// ǵһλڶƿ
									// ֱд
        VIC0INTENABLE = temp;
    }
    else if(intnum<64)
    {
        temp = VIC1INTENABLE;
        temp |= (1<<(intnum-32));
        VIC1INTENABLE = temp;
    }
    else if(intnum<96)
    {
        temp = VIC2INTENABLE;
        temp |= (1<<(intnum-64));
        VIC2INTENABLE = temp;
    }
    else if(intnum<NUM_ALL)
    {
        temp = VIC3INTENABLE;
        temp |= (1<<(intnum-96));
        VIC3INTENABLE = temp;
    }
    // NUM_ALL : enable all interrupt
    else
    {
        VIC0INTENABLE = 0xFFFFFFFF;
        VIC1INTENABLE = 0xFFFFFFFF;
        VIC2INTENABLE = 0xFFFFFFFF;
        VIC3INTENABLE = 0xFFFFFFFF;
    }

}

// ֹж
// ͨεintnumֹĳжԴжϺint.hж壬жϺ
void intc_disable(unsigned long intnum)
{
    unsigned long temp;

    if(intnum<32)
    {
        temp = VIC0INTENCLEAR;
        temp |= (1<<intnum);
        VIC0INTENCLEAR = temp;
    }
    else if(intnum<64)
    {
        temp = VIC1INTENCLEAR;
        temp |= (1<<(intnum-32));
        VIC1INTENCLEAR = temp;
    }
    else if(intnum<96)
    {
        temp = VIC2INTENCLEAR;
        temp |= (1<<(intnum-64));
        VIC2INTENCLEAR = temp;
    }
    else if(intnum<NUM_ALL)
    {
        temp = VIC3INTENCLEAR;
        temp |= (1<<(intnum-96));
        VIC3INTENCLEAR = temp;
    }
    // NUM_ALL : disable all interrupt
    else
    {
        VIC0INTENCLEAR = 0xFFFFFFFF;
        VIC1INTENCLEAR = 0xFFFFFFFF;
        VIC2INTENCLEAR = 0xFFFFFFFF;
        VIC3INTENCLEAR = 0xFFFFFFFF;
    }

    return;
}


// ͨȡVICnIRQSTATUSĴжĸһλΪ1֪ĸVICж
unsigned long intc_getvicirqstatus(unsigned long ucontroller)
{
    if(ucontroller == 0)
        return	VIC0IRQSTATUS;
    else if(ucontroller == 1)
        return 	VIC1IRQSTATUS;
    else if(ucontroller == 2)
        return 	VIC2IRQSTATUS;
    else if(ucontroller == 3)
        return 	VIC3IRQSTATUS;
    else
    {}
    return 0;
}


// жϴ˼˵ֻжϴǱ/ֳָ
void irq_handler(void)
{
	//printf("irq_handler.\n");
	// SoCֺ֧ܶڵͶCPU244030210100ж
	// ôжirqڵһ׶ߵһ·뵽irq_handler
	// irq_handlerҪȥ־ĸжϷˣȻȥøж
	// Ӧisr
	
	
	// ȻӲѾԶǰisrVICnADDRУΪ4Ǳ
	// ȥļĸVICжˣҲ˵isrĸVICADDRĴ
	unsigned long vicaddr[4] = {VIC0ADDR,VIC1ADDR,VIC2ADDR,VIC3ADDR};
    int i=0;
    void (*isr)(void) = NULL;

    for(i=0; i<4; i++)
    {
		// һжʱ4VIC3ȫ01һλ0
        if(intc_getvicirqstatus(i) != 0)
        {
            isr = (void (*)(void)) vicaddr[i];
            break;
        }
    }
    (*isr)();		// ָͨú
}







